<template>
    <div>
        <div v-if="$v.resultError.required" class="uk-alert-danger" uk-alert>
            <a v-on:click="resultError=''" class="uk-alert-close" uk-close></a>
            <p>{{resultError}}</p>
        </div>
        <div class="uk-card uk-card-default uk-card-body">
            <h3 class="uk-card-title">Adams Method</h3>
            <div class="uk-margin">
                <div>
                    <div>
                        <span v-katex="'y\'='"></span>
                        <input class="cw-input katex"
                               v-bind:class="{'cw-input katex-invalid':(!$v.funct.maxLength||!$v.funct.required)}"
                               v-model="funct" type="text">
                        <span v-if="$v.funct.required&&$v.funct.maxLength" class="uk-float-right math-expression"
                              v-katex="{ expression: 'y\'='+parseLatex() }"></span>
                    </div>
                    <div>
                        <span v-katex="'y('"></span>
                        <label>
                            <input v-bind:class="{'cw-input katex-invalid':(!$v.x0.maxLength||!$v.x0.required||!$v.x0.mathExpr)}"
                                   v-autowidth="{maxWidth: '40%', minWidth: '20px', comfortZone: 10}"
                                   class="cw-input katex resizable cw-input katex-small" style="text-align: center"
                                   v-model="x0" type="text">
                        </label>
                        <span v-katex="')='"></span>
                        <label>
                            <input v-bind:class="{'cw-input katex-invalid':(!$v.y0.maxLength||!$v.y0.required||!$v.y0.mathExpr)}"
                                   v-autowidth="{maxWidth: '40%', minWidth: '20px', comfortZone: 10}"
                                   class="cw-input katex resizable cw-input katex-small" style="text-align: center"
                                   v-model="y0" type="text">
                        </label>
                        <span v-if="$v.x0.required&&$v.x0.maxLength&&$v.x0.mathExpr&&$v.y0.required&&$v.y0.maxLength&&$v.y0.mathExpr"
                              class="uk-float-right math-expression"
                              v-katex="{ expression: 'y('+x0.toString().replace(/pi|Pi|PI|pI/,'\\pi')+')='+y0.toString().replace(/pi|Pi|PI|pI/,'\\pi') }"></span>
                    </div>
                    <div>
                        <label v-if="!$v.x0.$invalid">
                            <span v-katex="'x \\in ['+x0+', '"></span>
                            <input v-bind:class="{'cw-input katex-invalid':(!$v.b.maxLength||!$v.b.required||!$v.b.mathExpr)}"
                                   v-autowidth="{maxWidth: '40%', minWidth: '20px', comfortZone: 10}"
                                   class="cw-input katex resizable cw-input katex-small katex"
                                   style="text-align: center"
                                   v-model="b" type="text">
                            <!--<span v-katex="'y('"></span>-->
                            <span v-katex="']'"></span>
                            <!--<span v-if="resultLoader" uk-spinner="ratio: 1"></span>-->
                            <!--<span v-else v-katex="' '+ resultExpr"></span>-->
                        </label>
                        <div class="uk-float-right">
                           <span v-if="$v.resultExpr.required" class="math-expression"
                                  v-katex="{ expression: 'Result: '+resultExpr}"></span>
                        </div>

                    </div>
                    <label v-if="checkbox" class="uk-form-label">
                        <span v-katex="'h='+hop"></span>
                        <input id="rng" v-model="hop" class="uk-range" type="range" min="0.1"
                               max="1" step="0.1"/>
                    </label>

                    <div v-if="$v.requiredGroup.$invalid">
                        <div class="error" v-if="!$v.x0.maxLength||!$v.y0.maxLength">{{ errorLen($v.x0) }}</div>
                        <div class="error" v-if="!$v.funct.maxLength">{{ errorLen($v.funct) }}</div>
                        <div class="error" v-if="!$v.requiredGroup.required">Fields is required</div>
                        <div class="error" v-if="!$v.b.mathExpr||!$v.x0.mathExpr||!$v.y0.mathExpr">The field must
                            contain only numbers.
                        </div>
                    </div>
                    <hr>
                    <button :disabled="$v.requiredGroup.$invalid||resultLoader" v-on:click="solve"
                            class="uk-button uk-button-default uk-float-right">
                        <span v-if="resultLoader" uk-spinner="ratio: 1"></span>
                        <span v-if="!resultLoader">Solve</span>
                    </button>
                </div>
            </div>
        </div>
        <div v-if="(checkbox&&resultSegment.length!==0)" class="uk-card uk-card-body uk-card-hover uk-card-primary">
            <h3 class="uk-card-title">Result</h3>
            <div class="uk-margin">
                <div class="uk-overflow-auto ">
                    <span v-if="resultLoader" uk-spinner="ratio: 1"></span>
                    <table v-if="!resultLoader" class="uk-table uk-table-hover uk-table-divider uk-table-middle">
                        <thead>
                        <tr>
                            <th><span class="katex mathdefault" style="text-transform: none; font-size: medium">#</span>
                            </th>
                            <th><span class="katex mathdefault" style="text-transform: none; font-size: medium"
                                      v-katex="'x'"></span></th>
                            <th><span class="katex mathdefault" style="text-transform: none; font-size: medium"
                                      v-katex="'y'"></span></th>
                        </tr>
                        </thead>
                        <tbody>
                        <tr v-for="(item, index) in resultSegment">
                            <td>{{index}}</td>
                            <td>{{item.x}}</td>
                            <td>{{item.y}}</td>
                        </tr>
                        </tbody>
                    </table>
                </div>
            </div>
        </div>
    </div>
</template>
<script>

    import AsciiMathParser from 'asciimath2tex';
    import {required, maxLength} from 'vuelidate/lib/validators'
    import axios from 'axios';
    const RECAPTCHA_TOKEN = `6LfH7pcUAAAAAFQRu7gxejZzC57TYZY0qOwcDJmJ`;
    const parser = new AsciiMathParser();
    // const regex = /[0-9-]*(\\|(pi)|(Pi)|(PI)|e|E|\*|\/|\+|-|\^)*\.?[0-9-]*(\\|(pi)|(Pi)|(PI)|e|E|\*|\/|\+|-|\^)*/;
    const mathExpr = (value) => {
        return !(/[^pie./*\-+\d]/i.test(value))
    };
    export const HTTP = axios.create({
        baseURL: (process.env.NODE_ENV === 'development')?'http://localhost:8081/api':'https://cw.enderbot.ru/api',
        timeout: 36000,
        withCredentials: false,
        headers: {
            'Content-Type': 'application/json'
        }
    });
    export default {
        name: "Lab9",
        computed: {},
        data: function () {
            return {
                funct: '',
                x0: "",
                y0: '',
                b: '',
                hop: 0.5,
                resultExpr: '',
                resultLoader: false,
                resultError: '',
                checkbox: false,
                resultSegment: []
            }
        },
        methods: {
            recaptchaToken: async function () {
                return new Promise((resolve) => {
                    // noinspection JSUnresolvedVariable
                    // eslint-disable-next-line no-undef
                    grecaptcha.ready(async () => {
                        // noinspection ES6ModulesDependencies
                        // noinspection JSUnresolvedVariable
                        // eslint-disable-next-line no-undef
                        const token = await grecaptcha.execute(RECAPTCHA_TOKEN);
                        resolve(token);
                    });
                });
            },
            parseLatex: function () {
                if (this.funct === '') {
                    return ' ';
                }
                return parser.parse(this.funct.toString()).toString();
            },
            errorLen: function (field) {
                return 'Field must have at least ' + field.$params.maxLength.max + ' letters'
            },
            onSolveSegmentSucceeded: function (id) {
                HTTP.get('/lab9/segment', {
                    params: {
                        id: id
                    }
                }).then((response) => {
                    // this.resultExpr = response.data;
                    this.resultSegment = response.data
                }).catch((error) => {
                    if (error.response) {
                        console.error(error.response.data);
                        console.error(error.response.status);
                        console.error(error.response.headers);
                        this.resultError = error.data;
                    } else if (error.request) {
                        this.resultError = error.message;
                        console.error(error.code);
                        console.error(error.request);
                    } else {
                        this.resultError = error.message;
                        console.error('Error', error.message);
                    }
                });
            },
            onSolveScalarSucceeded: function (id) {
                HTTP.get('/lab9/scalar', {
                    params: {
                        id: id
                    }
                }).then((response) => {
                    this.resultExpr = response.data;
                }).catch((error) => {
                    if (error.response) {
                        console.error(error.response.data);
                        console.error(error.response.status);
                        console.error(error.response.headers);
                        this.resultError = error.data;
                    } else if (error.request) {
                        this.resultError = error.message;
                        console.error(error.code);
                        console.error(error.request);
                    } else {
                        this.resultError = error.message;
                        console.error('Error', error.message);
                    }
                });
            },
            solveScalar: function (data) {
                let axiosPromise = HTTP.post('/lab9/scalar', data);
                const self = this;
                axiosPromise.then((response) => {
                    console.log(response.data);
                    let url = 'https:///cw.enderbot.ru/api/notify/' + response.data;
                    // noinspection ES6ModulesDependencies
                    if (process.env.NODE_ENV === 'development') url = "http://localhost:8081/api/notify/" + response.data;
                    const eventSource = new EventSource(url);
                    eventSource.onmessage = function (e) {
                        console.log("Пришло уведомление: " + e.data);
                        if (e.data === 'success'||e.data === 'completed') {
                            self.onSolveScalarSucceeded(response.data);
                            eventSource.close();
                            // noinspection JSPotentiallyInvalidUsageOfThis
                            self.resultLoader = false;
                        }
                    };
                    eventSource.onerror = function (error) {
                        self.resultError = error.data;
                        // noinspection JSPotentiallyInvalidUsageOfThis
                        eventSource.close();
                    };

                    console.log(response);
                }).catch((error) => {
                    if (error.response) {
                        console.error(error.response.data);
                        console.error(error.response.status);
                        console.error(error.response.headers);
                        this.resultError = error.data;
                    } else if (error.request) {
                        this.resultError = error.message;
                        console.error(error.code);
                        console.error(error.request);
                    } else {
                        this.resultError = error.message;
                        console.error('Error', error.message);
                    }
                    this.resultLoader = false;

                })
            },
            solveSegment: function (data) {
                const self = this;
                let axiosPromise = HTTP.post('/lab9/segment', data);
                axiosPromise.then((response) => {
                    console.log(response.data);
                    let url = 'https:///cw.enderbot.ru/api/notify/' + response.data;
                    // noinspection ES6ModulesDependencies
                    if (process.env.NODE_ENV === 'development') url = "http://localhost:8081/api/notify/" + response.data;
                    var eventSource = new EventSource(url);
                    eventSource.onmessage = function (e) {
                        console.log("Пришло уведомление: " + e.data);
                        if (e.data === 'success'||e.data === 'completed') {
                            self.onSolveSegmentSucceeded(response.data);
                            eventSource.close();
                            // noinspection JSPotentiallyInvalidUsageOfThis
                            self.resultLoader = false;

                        }
                    };
                    eventSource.onerror = function (error) {
                        self.resultError = error.data;
                        // noinspection JSPotentiallyInvalidUsageOfThis
                        self.resultLoader = false;
                        eventSource.close();
                    };

                    console.log(response);
                }).catch((error) => {
                    if (error.response) {
                        console.error(error.response.data);
                        console.error(error.response.status);
                        console.error(error.response.headers);
                        this.resultError = error.data;
                    } else if (error.request) {
                        this.resultError = error.message;
                        console.error(error.code);
                        console.error(error.request);
                    } else {
                        this.resultError = error.message;
                        console.error('Error', error.message);
                    }
                    this.resultLoader = false;

                })
            },
            solve: async function () {
                this.resultLoader = true;
                const token = await this.recaptchaToken();

                let data = {
                    'token': token,
                    'data': {
                        'function': this.funct,
                        'beginY': this.y0,
                        'beginX': this.x0,
                        'end': this.b,
                        'hop': this.hop,
                        'precision': 1e-2
                    }
                };
                if (this.checkbox) {
                    this.resultSegment = [];
                    this.solveSegment(data);
                } else {
                    this.resultSegment = [];
                    this.solveScalar(data);
                }
            }
        },
        validations: {
            resultError:{
              required
            },
            x0: {
                mathExpr,
                required,
                maxLength: maxLength(27),
            },
            y0: {
                mathExpr,
                required,
                maxLength: maxLength(27),
            },
            funct: {

                required,
                maxLength: maxLength(64),
            },
            b: {
                mathExpr,
                required,
                maxLength: maxLength(32),
            },
            resultExpr: {
                required,
            },
            requiredGroup: ['x0', 'y0', 'funct', 'b'],
            digitsGroup: ['x0', 'y0', 'b'],
        }


    }

    //    <--table.uk-table.uk-table-hover.uk-table-divider.uk-table-middle>(thread>tr>th.uk-table-shrink*3<{Item $})+tbody>(tr>td*3>{Text $})*3-->
</script>
<style lang="less">

</style>
